<?


function rnd_str($char_num=0)
{
    $abc = str_shuffle('abcdefghijklmnopqrstuvwxyz');
    $res = '';
    
    for($i=0; $i<$char_num; $i++)
    {
        $res .= $abc[rand(0, strlen($abc)-1)]; 
    }
    
    return $res;  
}


function vd(&$var)
{
    ob_start();
    var_dump($var);
    $cnt=ob_get_contents();
    ob_end_clean();
    return nl2br(str_replace(' ','&nbsp;&nbsp;&nbsp;&nbsp;',htmlspecialchars($cnt)));
}








interface db_itrfc
{
    public function query($query);
    public function res_query($query);
    public function get_query_info();
}



class simple_db implements db_itrfc
{
    protected $db_host = '';
    protected $db_user = '';
    protected $db_pwd = '';
    protected $db_rsc = null;
    protected $query_info = array();
    
    public $db_messages = array();
    

    public function __construct($host='', $user='', $pwd='')
    {
        $this->db_host = $host;
        $this->db_user = $user;
        $this->db_pwd = $pwd;
        
        $this->db_rsc = @mysql_connect($this->db_host, $this->db_user, $this->db_pwd);
        
        if(!$this->db_rsc)
        {
            $this->db_messages[] = 'Error #'.mysql_errno().': '.mysql_error();

            return false;
        }
        else
        {
            $this->db_messages[] = 'Connect ok';
            
            return true;
        }
    }
    
    public function __destruct()
    {
        return @mysql_close($this->db_rsc);
    }
    
    protected function collect_info()
    {
        $this->query_info['id'] = mysql_insert_id($this->db_rsc);
        $this->query_info['info'] = mysql_info($this->db_rsc);
        
        return;
    }
    
    protected function push_error()
    {
        $this->db_messages[] = 'Error #'.mysql_errno($this->db_rsc).': '.mysql_error($this->db_rsc);
        return false;
    }

    public function query($query)
    {
        $res = null;
        $res = mysql_query($query, $this->db_rsc);
        $this->collect_info();
        
        return $res;
    }
    
    public function res_query($query)
    {
        $result = array();
        $result_query = false;
        $result_query = mysql_query($query, $this->db_rsc);
        $this->collect_info();
        
        if(!$result_query)
        {
            return $this->push_error();
        }
        else
        {
            while($row = mysql_fetch_assoc($result_query))
            {
                $result[] = $row;
            }
        
            return $result;
        }
    }

    public function get_query_info()
    {
        return $this->query_info;
    }
}



class db_utility
{
    protected $db_name = 'api_test';
    protected $api_table = 'api';
    protected $args_table = 'api_args';
    protected $data_table = 'data';
    protected $basic_queries = array();
    protected $db_handler = null;
    
    public function __construct($db_object)
    {
        $this->db_handler = $db_object;
        $this->create_queries();
    }
    
    protected function create_queries()
    {
        $this->basic_queries[] = 'DROP DATABASE IF EXISTS `'.$this->db_name.'`';
        $this->basic_queries[] = 'CREATE DATABASE `'.$this->db_name.'`';
        $this->basic_queries[] = 'USE `'.$this->db_name.'`';
        $this->basic_queries[] = 'DROP TABLE IF EXISTS `'.$this->api_table.'`';
        $this->basic_queries[] = 'CREATE TABLE `'.$this->api_table.'`(' .
                                'id INT not null auto_increment primary key, func_name char(255) binary not null, ' .
                                ' arg_num tinyint not null, ret_type char(255) binary not null)';
        $this->basic_queries[] = 'drop table if exists `'.$this->args_table.'`';
        $this->basic_queries[] = 'create table `'.$this->args_table.'`(' .
                                'id int not null auto_increment primary key, aid int not null, arg_name char(255) binary not null, '.
                                'arg_type char(255) binary not null)';
        $this->basic_queries[] = 'drop table if exists `'.$this->data_table.'`';
        $this->basic_queries[] = 'create table `'.$this->data_table.'`(' .
                                'id int not null auto_increment primary key, f_name char(255) binary not null, '.
                                'l_name char(255) binary not null)';
        
        for($i=0; $i< rand(10, 50); $i++)
        {
            $this->basic_queries[] = 'insert into `'.$this->data_table.'` values (' .
                                    'NULL, "'.rnd_str(rand(3, 10)).'", "'.rnd_str(rand(3, 10)).'")';
        }

        return;
    }
 
    public function run()
    {
        for($i=0; $i<sizeof($this->basic_queries); $i++)
        {
            $this->db_handler->query($this->basic_queries[$i]);
        }

        return;
    }
}


class api
{
    protected $db_name = 'api_test';
    protected $api_table = 'api';
    protected $args_table = 'api_args';
    protected $data_table = 'data';
    protected $db_handler = null;
    
    public function __construct($db_object)
    {
        $this->db_handler = $db_object;
        $this->db_handler->query('use `'.$this->db_name.'`');
    }
}


class api_list_utility extends api
{
    protected $basic_queries = array();
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->create_functions();
    }
    
    protected function create_functions()
    {
        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_user", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "id", "int")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "delete_user", "1", "bool")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "id", "int")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "add_user", "2", "bool")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "fname", "string")'
                                                    ,'insert into `'.$this->args_table.'` values (NULL, ?, "lname", "string")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "add_users", "1", "bool")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "udata", "array")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_users_or", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "cases", "array")'
                                                )
                                    );

        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_users_and", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "cases", "array")'
                                                )
                                    );


        $this->basic_queries[] = array(
                                    'func' => 'insert into `'.$this->api_table.'` values (NULL, "get_users", "1", "array")',
                                    'args' => array(
                                                    'insert into `'.$this->args_table.'` values (NULL, ?, "void", "string")'
                                                )
                                    );
        return;
    }
 
    
    public function run()
    {
        $info = array();
        
        for($i=0; $i<sizeof($this->basic_queries); $i++)
        {
            $this->db_handler->query($this->basic_queries[$i]['func']);
            $info = $this->db_handler->get_query_info();

            for($j=0; $j<sizeof($this->basic_queries[$i]['args']); $j++)
            {
                $this->basic_queries[$i]['args'][$j] = str_replace('?', $info['id'], $this->basic_queries[$i]['args'][$j]);
                $this->db_handler->query($this->basic_queries[$i]['args'][$j]);
            }
            
        }

        return;
    }
}


interface api_list_itrfc
{
    public function get_api($func=''); //ret array of all functions or 1 function if get function's name
    public function api_func_exists($func_name='');
    public function chk_args($fname, $args=array());
    //public function chk_ret($fname, $args=array());
}


class api_list extends api implements api_list_itrfc
{ 
    public function __construct($db_object)
    {
        parent::__construct($db_object);
    }

    public function get_api($func='')
    {
        if(isset($func) && !empty($func))
        {
            return $this->get_api_func($func);
        }
        else
        {
            return $this->get_all_api();
        }
    }

    public function api_func_exists($func_name='')
    {
        $array = array();
        $array = $this->get_api($func='');
        
        if(isset($func_name) && is_string($func_name) && !empty($func_name))
        {
            for($i=0; $i<sizeof($array); $i++)
            {
                if($array[$i]['func']['func_name'] == $func_name)
                {
                    return true;
                }
            }
            
            return false;
        }
        else
        {
            return false;
        }
    }

/*
    public function chk_ret($fname, $args=array())
    {
    }
*/


    public function chk_args($fname, $args=array())
    {
        $fdata = array();
        $adata = array();
        $fdata = $this->get_api_func($fname);

        if(is_array($args) && is_array($fdata) && isset($fdata[0]['args']) && (sizeof($args) == sizeof($fdata[0]['args'])))
        {
            $adata = $fdata[0]['args'];
            $flag = false;

            for($i=0; $i<sizeof($adata); $i++)
            {
                foreach($args as $key=>$val)
                {
                    if($adata[$i]['arg_name']==$key)
                    {
                        $flag = true;

                        if($this->chk_types($adata[$i]['arg_type'], $val))
                        {
                            break;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
                
                if(!$flag)
                {
                    return false;
                }
                else
                {
                    $flag = false;
                }
            }
            
            return true;
        }
        else
        {
            return false;
        }
    }

    protected function chk_types($type, $val)
    {
        switch ($type)
        {
            case 'string':
                return is_string($val);
            
            case 'array':
                return is_array($val);
            
            case 'int':
                return is_int($val);
            
            case 'bool':
                return is_bool($val);

            case 'void':
                return (!isset($val) || empty($val)) ?  true : false;
                
            default:
            return false;
        }
    }


    protected function get_all_api()
    {
        $func_data = array();
        $arg_data = array();

        $func_data = $this->db_handler->res_query('SELECT * '.
                                                    'FROM `'.$this->api_table.'`' .
                                                '');

        $arg_data = $this->db_handler->res_query('SELECT * '.
                                                    'FROM `'.$this->args_table.'`' .
                                                '');
                                                
        return $this->api_list_array($func_data, $arg_data);
    }

    protected function get_api_func($func)
    {
        $func_data = array();
        $arg_data = array();

        $func_data = $this->db_handler->res_query('SELECT * '.
                                                  'FROM `'.$this->api_table.'`' .
                                                'WHERE func_name = "'.$func.'"');

        $arg_data = $this->db_handler->res_query('SELECT * '.
                                                    'FROM `'.$this->args_table.'`' .
                                                'WHERE aid = "'.$func_data[0]['id'].'" ');

        return $this->api_list_array($func_data, $arg_data);
    }


    protected function api_list_array($func_data, $arg_data)
    {
        $res = array();

        if((is_array($func_data) && !empty($func_data)) && (is_array($arg_data) && !empty($arg_data)))
        {
            for($i=0; $i<sizeof($func_data); $i++)
            {
                $res[$i]['func'] = array('func_name'=>$func_data[$i]['func_name'] 
                                        ,'arg_num'=>$func_data[$i]['arg_num']
                                        ,'ret_type'=>$func_data[$i]['ret_type']
                                        );
                  
                for($j=0; $j<sizeof($arg_data); $j++)
                {
                    if($func_data[$i]['id'] == $arg_data[$j]['aid'])
                    {
                        $res[$i]['args'][] =  array('arg_name'=>$arg_data[$j]['arg_name'], 'arg_type'=>$arg_data[$j]['arg_type']);
                    }
                }
            }
    
            return $res;
        }
        else
        {
            return false;
        }
    }
}



interface api_functions_itrfc
{
    public function delete_user($id);
    public function add_user($fname, $lname);
    public function add_users($udata);
    public function get_user($id);
    public function get_users();
    public function get_users_and($cases);
    public function get_users_or($cases);
}


class api_functions extends api implements api_functions_itrfc 
{
    public function __construct($db_object)
    {
        parent::__construct($db_object);
    }
    
    public function delete_user($id)
    {
        return $this->db_handler->query('DELETE FROM `'.$this->data_table.'` WHERE id = "'.$id.'"');
    }


    public function add_user($fname, $lname)
    {
        return $this->db_handler->query('INSERT LOW_PRIORITY INTO  `'.$this->data_table.'` values (NULL, "'.$fname.'", "'.$lname.'")');
    }
    
    public function add_users($udata)
    {
        $query = 'INSERT LOW_PRIORITY INTO `'.$this->data_table.'` (id, f_name, l_name) values ';
        
        if(is_array($udata) && !empty($udata))
        {
            for($i=0; $i<sizeof($udata); $i++)
            {
                if($i!=0)
                {
                    $query .= ', '; 
                }

                $query .= '(NULL, "'.$udata[$i]['fname'].'", "'.$udata[$i]['lname'].'" )';
            }
            
            return $this->db_handler->query($query);
        }
        else
        {
            return false;
        }
    }
    
    public function get_user($id)
    {
        return $this->db_handler->res_query('SELECT * FROM `'.$this->data_table.'` WHERE id = '.$id);
    }
    
    public function get_users()
    {
        return $this->db_handler->res_query('SELECT * FROM `'.$this->data_table.'`');
    }
    
    public function get_users_and($cases)
    {
        $query = 'SELECT * FROM `'.$this->data_table.'` WHERE ';
        
        if(is_array($cases) && !empty($cases))
        {
            $j = 0;

            for($i=0; $i<sizeof($cases); $i++)
            {
                foreach($cases[$i] as $key => $val)
                {
                    if($j!=0)
                    {
                        $query .= ' AND ';
                    }
                    
                    $query .= '('.$key.' = "'. $val.'")';
                    
                    $j++;
                }
            }

            return $this->db_handler->res_query($query);
        }
        else
        {
            return false;
        }
    }
    
    public function get_users_or($cases)
    {
        $query = 'SELECT * FROM `'.$this->data_table.'` WHERE ';
        
        if(is_array($cases) && !empty($cases))
        {
            $j = 0;
            
            for($i=0; $i<sizeof($cases); $i++)
            {
                foreach($cases[$i] as $key => $val)
                {
                    if($j!=0)
                    {
                        $query .= ' OR ';
                    }
                    
                    $query .= '('.$key.' = "'. $val.'")';
                    
                    $j++;
                }
            }
            
            return $this->db_handler->res_query($query);
        }
        else
        {
            return false;
        }
    }

}



class api_executor extends api
{
    protected $api_list = null;
    protected $api_functions = null;
    
    public function __construct($db_object)
    {
        parent::__construct($db_object);
        $this->api_list = new api_list($this->db_handler);
        $this->api_functions = new api_functions($this->db_handler);
    }
    
    
    public function execute($func_name, $args=array())
    {
        $res = null;
        
        if($this->api_list->api_func_exists($func_name) && $this->api_list->chk_args($func_name, $args))
        {
            $callback_array = array($this->api_functions, $func_name);

            if(is_callable($callback_array, true, $func_name))
            {
                $res = call_user_func_array($callback_array, $args);
                
                return $res;
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }
}
